const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const WhereSchema = new Schema({
  _id: {
    type: mongoose.Schema.Types.ObjectId
  },
  idapp: {
    type: String,
  },
  code: {
    type: String,
  },
  placename: {
    type: String,
  },
  whereicon: {
    type: String,
  },
});

WhereSchema.statics.getFieldsForSearch = function () {
  return [{ field: 'placename', type: tools.FieldType.string }]
};

WhereSchema.statics.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

WhereSchema.statics.findAllIdApp = async function (idapp) {
  const Where = this;

  const myfind = { idapp };

  return await Where.find(myfind, (err, arrrec) => {
    return arrrec
  });
};

const Where = mongoose.model('Where', WhereSchema);

module.exports = { Where };
